package com.zxbw.modulemain.activity

import android.content.Intent
import android.net.Uri
import android.os.Handler
import android.util.Log
import android.view.View
import android.webkit.*
import androidx.recyclerview.widget.LinearLayoutManager
import com.zxbw.modulemain.R
import com.zxhl.cms.AppContext
import com.zxhl.cms.common.Constant
import com.zxhl.cms.common.NetConfig
import com.zxhl.cms.common.base.BaseActivity
import com.zxhl.cms.net.ApiClient
import com.zxhl.cms.net.RxSchedulers
import com.zxhl.cms.net.SettingPreference
import com.zxhl.cms.net.callback.BaseObserver
import com.zxhl.cms.net.model.box.AppInEntity
import com.zxhl.cms.net.model.uc.PayResultEntity
import com.zxhl.cms.net.model.video.MemberEntity
import com.zxhl.cms.pay.PayContract
import com.zxhl.cms.pay.PayPresenter
import com.zxhl.cms.pay.PaymentFunAdapter
import com.zxhl.cms.utils.*
import com.zxhl.cms.widget.LoadingDialog
import io.reactivex.Observable
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.functions.Consumer
import kotlinx.android.synthetic.main.activity_layout_member_order.*
import java.util.*

/**
 * @author (wangXuewei)
 * @datetime 2022-05-30 14:12 GMT+8
 * @detail :
 */
class OpenMemberOrderActivity : BaseActivity(), PayContract.View {
    private var mPresenter: PayContract.Presenter? = null
    private var payResultObservable: Observable<PayResultEntity>? = null
    private var mPayFunAdapter: PaymentFunAdapter? = null;
    private var mLoading: LoadingDialog? = null

    companion object {
        const val ALI_PAY = 1   //支付宝支付类型
        const val WECHAT_PAY = 2  //微信支付类型
        const val MINI_PROGRAM = 11  //微信支付类型
        const val MIN_PAY_PROGRAM = 13  //敏付
        const val H5_PAY = 21  //h5支付
    }

    private var pay_type: Int? = 0
    override fun before() {
        super.before()
        setStatusBarBackground(AppContext.get().resources.getColor(R.color.transparent))
    }

    override fun onClick(v: View?) {

    }

    override fun layoutID(): Int {
        return R.layout.activity_layout_member_order
    }

    override fun init() {
        mLoading = LoadingDialog.getLoadingDialog(
            this,
            getString(R.string.wait_ing),
            false,
            false
        )
        mPresenter = PayPresenter(this)
        payResultObservable = RxBus.get().register(Constant.PAY_RESULT, PayResultEntity::class.java)
        payResultObservable?.observeOn(AndroidSchedulers.mainThread())
            ?.subscribe(Consumer<PayResultEntity> { obj ->
                MainLooper?.get()?.postDelayed(Runnable {
                    mHandler?.removeCallbacksAndMessages(null)
                }, 1000)
                Log.d("qqbs", "verifyPay:${obj.txt}")
                //println("verifyPay payResultObservable------------------------------- order:${obj.txt}")
                if (obj.isPaySuc) {
                    mPresenter?.verifyPay(obj.txt, obj.payType)
                } else {
                    //支付宝支付
                    if (obj.payType == 1) {
                        if (obj.payStatus == "6001") {
                            EventUtils.onEvent("zfb_pay_cancel")
                        } else {
                            EventUtils.onEvent("zfb_pay_error", obj.payStatus + " msg:" + obj.txt)
                        }
                    } else {
                        EventUtils.onEvent("wx_pay_error", obj.txt)
                    }
                    showResultLoading(false)
                }
            }, Consumer<Throwable> { })

        val userInfoData = SettingPreference.getUserInfoData()
        if (userInfoData != null) {
            id_tv_user_vip_phone.text = userInfoData.nickname
        }

        vipTime()

        mPayFunAdapter = PaymentFunAdapter(
            this
        ) { view, position, data ->
            pay_type = data.type
            mPayFunAdapter?.setPosition(position)
        }
        id_rcl_vip_payment_list.layoutManager = LinearLayoutManager(this)
        id_rcl_vip_payment_list.adapter = mPayFunAdapter
        id_tv_open_vip_btn_pay?.setOnClickListener {
            gotoPay()
        }
        id_img_back?.setOnClickListener {
            finish()
        }
    }

    override fun data() {
        super.data()
        mPresenter?.appInfo()
        getPayList()
    }

    private fun gotoPay() {
        if (pay_type == 0) {
            Utils.showToast(this, "请选择支付类型")
            return
        }
        if (payData == null) {
            Utils.showToast(this, "订单获取异常")
            return
        }
        mLoading?.setLoading("请稍后")
        mLoading?.show()

        if (pay_type == ALI_PAY) {
            mPresenter?.requestAliPay(
                this,
                payData?.goodsId ?: "",
                pay_type.toString(),
                "5"
            )
        } else if (pay_type == WECHAT_PAY) {
            Log.e("MXL", "2微信原生支付")
            mPresenter?.requestWechatPayOrder(
                payData?.goodsId ?: "",
                pay_type.toString()
            )
        } else if (pay_type == MINI_PROGRAM) {
            Log.e("MXL", "2微信连连支付")
            mPresenter?.requestWechatPayOrder(
                payData?.goodsId ?: "",
                pay_type.toString()
            )
        } else {
            Log.e("MXL", "2支付宝敏支付")
            mPresenter?.requestMiniProgrom(
                payData?.goodsId ?: "",
                pay_type.toString(),
                "5"
            )
        }

    }

    override fun updatePriceList(data: List<MemberEntity.ProductDetail>) {

    }

    override fun verifyOrderFail(errorMsg: String) {
        EventUtils.onEvent("pay_fail", errorMsg)
        showResultLoading(false)
    }

    override fun requestOrderSuc() {
        mLoading?.setLoading("正在支付")
    }

    override fun requestH5OrderSuc(form: String) {
        if (form.isEmpty()) {
            EventUtils.onEvent("h5_pay_error")
            showResultLoading(false)
        } else {
            loadH5Pay(form)
        }
    }

    override fun verifyOrderSuc(orsder: String) {
        EventUtils.onEvent("pay_suc")
        UserDataUtils.updateUserInfo(object : AdCallback<String> {
            override fun onResult(code: Int, result: String?) {
                Constant.Switch.isOpenVip = true
                val userInfoData = SettingPreference.getUserInfoData()
                if (userInfoData != null) {
                    Constant.Switch.isOpenVip = userInfoData.member
                }
                showResultLoading(true)
                finish()
            }
        })

    }

    override fun setCanInvest(boolean: Boolean?) {

    }

    override fun setOrderNo(order: String?) {

    }

    override fun setAppInfo(result: AppInEntity?) {
        if (result != null && !result.pay_config_v2.isNullOrEmpty()) {
            mPayFunAdapter?.clear()
            mPayFunAdapter?.appendToList(result.pay_config_v2)
            for (i in result.pay_config_v2!!.indices) {
                if (result?.pay_config_v2!![i].open == 1) {
                    pay_type = result?.pay_config_v2!![i].type
                    mPayFunAdapter?.setPosition(i)
                    break
                }
            }
        }
    }


    private fun showResultLoading(isPaySuc: Boolean) {
        if (isPaySuc) {
            mLoading?.setResult(true, "支付成功", 1000)
        } else {
            mLoading?.setResult(false, "支付失败", 1000)
        }
    }

    private var mHandler: Handler = Handler {
        when (it.what) {
            0 -> {
                if (mLoading != null) {
                    mLoading?.setResult(false, "取消支付", 1000)
                }
            }
        }
        false
    }

    private var isPause = false
    override fun onResume() {
        super.onResume()
        if (isPause) {
            if (pay_type == MIN_PAY_PROGRAM || pay_type == H5_PAY) {
                //如果是敏支付或者H5支付
                mPresenter?.verifyPay(SettingPreference.getOutTradeNo(), pay_type!!)
            } else {
                mHandler?.sendEmptyMessageDelayed(0, 2000)
            }
        }
    }

    override fun onPause() {
        super.onPause()
        isPause = true
    }

    override fun onDestroy() {
        super.onDestroy()
        timer?.cancel()
        timer = null
    }

    private fun loadH5Pay(form: String) {
        val webSettings = id_member_pay_web_view.settings
        //如果访问的页面中要与Javascript交互，则webview必须设置支持Javascript
        webSettings.javaScriptEnabled = true
        //设置自适应屏幕，两者合用
        webSettings.useWideViewPort = true //将图片调整到适合webview的大小
        webSettings.loadWithOverviewMode = true // 缩放至屏幕的大小
        //其他细节操作
        webSettings.cacheMode = WebSettings.LOAD_NO_CACHE //关闭webview中缓存
        webSettings.allowFileAccess = true //设置可以访问文件
        webSettings.javaScriptCanOpenWindowsAutomatically = true //支持通过JS打开新窗口
        webSettings.loadsImagesAutomatically = true //支持自动加载图片
        webSettings.defaultTextEncodingName = "utf-8" //设置编码格式
        webSettings.domStorageEnabled = true
        webSettings.allowFileAccessFromFileURLs = true;
        webSettings.allowUniversalAccessFromFileURLs = true;

        id_member_pay_web_view?.webViewClient = object : WebViewClient() {
            override fun shouldOverrideUrlLoading(view: WebView?, url: String?): Boolean {
                Log.e("WXW", "dURL" + url.toString())
                if (url == null) return false
                try {
                    if (url.startsWith("alipays://") //支付宝
                    ) {
                        val intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
                        startActivity(intent)
                        return true
                    }
                } catch (e: Exception) { //防止crash (如果手机上没有安装处理某个scheme开头的url的APP, 会导致crash)
                    EventUtils.onEvent("h5_open_zfb_error", e.toString())
                    showResultLoading(false)
                    return true //没有安装该app时，返回true，表示拦截自定义链接，但不跳转，避免弹出上面的错误页面
                }
                //处理http和https开头的url
                view?.loadUrl(url)
                return false
            }

            override fun onPageFinished(view: WebView?, url: String?) {
                Log.e("WXW", "cURL" + url.toString())
                Log.d("wxw", "EndTime" + System.currentTimeMillis())
                super.onPageFinished(view, url)
                if (url?.contains(NetConfig.H5.WEB_URL_H5_PAY) == true) {
                    id_member_pay_web_view?.loadUrl("javascript:loadPayHtml('$form')");
                }
            }

            override fun onReceivedError(
                view: WebView?,
                request: WebResourceRequest?,
                error: WebResourceError?
            ) {
                super.onReceivedError(view, request, error)
                EventUtils.onEvent("h5_pay_error1", error.toString())
                showResultLoading(false)
            }

            override fun onReceivedHttpError(
                view: WebView?,
                request: WebResourceRequest?,
                errorResponse: WebResourceResponse?
            ) {
                super.onReceivedHttpError(view, request, errorResponse)
                EventUtils.onEvent("h5_pay_error2", errorResponse.toString())
                showResultLoading(false)
            }
        }
        id_member_pay_web_view.loadUrl(NetConfig.H5.WEB_URL_H5_PAY)

    }

    var timer: Timer? = null
    private fun vipTime() {
        var timeCount = 15 * 60
        // 创建计时器对象
        timer = Timer()
        // 创建计时器任务
        var timerTask: TimerTask = object : TimerTask() {
            override fun run() {
                timeCount--;
                runOnUiThread {
                    id_tv_vip_lock_time.text = Utils.timeConversion2(timeCount)
                    if (timeCount == 0) {
                        timer?.cancel()
                        //mDialog.dismiss()
                    }
                }
            }
        }
// 添加任务，设定开始计时器时间，第2个参数为时间单位毫秒，如果是0，立即执行
        timer?.schedule(timerTask, 0, 1000)
    }

    private var payData: MemberEntity.ProductDetail? = null;
    private fun getPayList() {
        ApiClient.videoInfoApi.getPayConfig("vip").compose(RxSchedulers.observableIO2Main())
            .subscribe(object : BaseObserver<MemberEntity>() {
                override fun onSuccess(result: MemberEntity?) {
                    if (!result?.goodsList.isNullOrEmpty()) {
                        if (result?.goodsList?.size!! >= 1) {
                            payData = result.goodsList!![0]
                            id_tv_vip_price.text = "${payData?.cash}元"
                            id_tv_vip_price2.text = payData?.cash
                            id_tv_vip_price3.text = "原价¥${payData?.originalPrice}"
                        }
                    }
                }

                override fun onFailure(e: Throwable?, code: String?, errorMsg: String?) {
                }
            })
    }
}